<?php

ob_start();

require 'jsffun.php';

$parser = new JSF_Parser('basic');
$parser->ParseSyntax(file('basic_vm.jsf'));

#print_r($parser);exit;

for(;;) // Merge identical states
{
  $states_hash   = Array();
  $states_rename = Array();
  $n_rename = 0;
  foreach($parser->state as $statename => $statedata)
  {
    unset($statedata['name']);
    $s = serialize($statedata);
    if(isset($states_hash[$s]))
    {
      ++$n_rename;
      $states_rename[$statename] = $states_hash[$s];
      #print "- rename $statename to {$states_hash[$s]}\n";
    }
    else
    {
      $states_rename[$statename] = $statename;
      $states_hash[$s] = $statename;
    }
  }
  if(!$n_rename) break;

  foreach($parser->state as $statename => &$statedata)
  {
    foreach($statedata['options'] as &$targetstate)
    {
      $targetstate['state'] = $states_rename[$targetstate['state']];
      foreach($targetstate['table'] as &$targetstate2)
        $targetstate2 = $states_rename[$targetstate2];
      unset($targetstate2);
    }
    unset($targetstate);
  }
  foreach($states_rename as $k=>$v)
    if($k != $v)
      unset($parser->state[$k]);
  unset($statedata);
}
#print_r($parser);exit;

foreach($parser->color as $name => $defs)
{
  $egacolor = 0x00;
  print "%define $name \t " . sprintf('0x%02X', $egacolor)."\n";
}



?>

;;;;
;;;;
bits 16
org 100h
;;;;
;;;;

jmp st_newline

;;;;;;;;;;;;;;;;;;;;; UTILITY

;;;;
test_string:
	pop bp        ; at [bp], is labels address
	push bp       ; ss conveniently points to cs, so we use bp here.
test_string_loop:
	lodsw
	cmp al, [bp+2]       ; 2 = string starting offset
	jne test_string_fail
	inc bp
	cmp si, bx
	jb test_string_loop
test_string_match:
        pop bp
        mov bp, [bp]
	jmp word [bp+2]
test_string_fail:
	pop bp
        mov bp, [bp]
	jmp word [bp+0]

;;;;
test_string_uc:
	pop bp        ; at [bp], is labels address
	push bp       ; ss conveniently points to cs, so we use bp here.
test_string_loop_uc:
	call takefrombuffer_uc
	cmp al, [bp+2]       ; 2 = string starting offset
	jne test_string_fail
	inc bp
	cmp si, bx
	jb test_string_loop_uc
	jmp test_string_match

;;;;
takefrombuffer_uc:
	lodsw
makeucase:
	cmp al, 'a'
	jb notlc
	cmp al, 'z'
	ja notlc
	sub al, 32
notlc:	ret

;;;;
binarysearch:
	; don't use: si = source pointer
	;            bx = end pointer
	;            cx = string length
	;            al = input
	; can use:   bp
	;            di
	;            dx
	;            ah
	pop bp ; ss conveniently points to cs, so we use bp here.
	movzx dx, byte[bp]  ; dl=upper limit (exclusive), dh=lower limit
	; Note: yes, they are vice versa. This is intentional.
	; This way, we get hi=count, lo=0 with one instruction.
	jmp binarysearch_loop_assume_nonempty
binarysearch_larger:
	inc ah
	mov dh, ah
	;; jmp binarysearch_loop ;Redundant jump
binarysearch_loop:
	cmp dh, dl
	jae binarysearch_fail
binarysearch_loop_assume_nonempty:
	mov ah, dh
	add ah, dl
	shr ah, 1
	movzx di, ah
	cmp al, [bp+di+3]
	jnbe binarysearch_larger
binarysearch_smaller:
	mov dl, ah
	jne binarysearch_loop
	;; jmp binarysearch_match ;Redundant jump
binarysearch_match:
	movzx dx, byte[bp]
	add di, di ; byte-to-word size
	add bp, dx ; skip over the character options
	jmp word [bp+di+3]  ; bp + ah*2 + dl + 3
binarysearch_fail:
	jmp word [bp+1]


;;;;
paint_token:
	lea si,[bx+1]
paint_token_loop:
	sub si, 2
	mov [si], ah
	loop paint_token_loop
	ret
test_newline:
	mov ax, si
	mov cx, 80*2
	xor dx, dx
	div cx
	test dx, dx
	ret

test_space:
	cmp al,32
	je end_test_space
	cmp al,255
	je end_test_space
	or al,al
end_test_space:
	ret

;powers_of_two:
;  dw 0x0001,0x0002,0x0004,0x0008
;  dw 0x0010,0x0020,0x0040,0x0080
;  dw 0x0100,0x0200,0x0400,0x0800
;  dw 0x1000,0x2000,0x4000,0x8000
;powers_of_two8:
;  db 0x01,0x02,0x04,0x08
;  db 0x10,0x20,0x40,0x80

;;;;;;;;;;;;;;;;;;; PARSING

<?php

$max_recolor_per_state = Array();
$reached_with_noeat    = Array();
$buffer_states         = Array();

$strings_states        = Array();

foreach($parser->state as $name => $defs)
  foreach($defs['options'] as $option)
  {
    $r = &$max_recolor_per_state[$option['state']];
    $r = max( (int)$r, -$option['recolor'] );
    if($option['noeat'])
      $reached_with_noeat[$option['state']] = true;

    if($option['buffer'])
    {
      $label1 = GenLabel($option);
      $option['buffer'] = 0;
      $label2 = GenLabel($option);
      $buffer_states[$label1] = $label2;
    }
    if($option['strings'])
    {
      $label1 = GenLabel($option);
      $s = $option['strings'];
      $option['strings'] = 0;
      $label2 = GenLabel($option);
      $strings_states[ $label1 ] = Array($s, $option['table'], $label2);

      foreach($option['table'] as $k => $v)
        $reached_with_noeat[$v] = true;
    }
  }
unset($r);

$chain_jumps = Array();

foreach($parser->state as $name => $defs)
{
  $opts = $defs['options'];

  $max_recolor = (int) @$max_recolor_per_state[$name];

  if(isset($reached_with_noeat[$name]))
  {
    print
      "st_{$name}_noeat:\n";

    if(count($opts) == 1 && $opts[0]['noeat'])
    {
      $opt = $opts[0];
      print "\t; reduced version\n";
      print "\tjmp ".GenLabel($opt)."\n";
      $chain_jumps["st_{$name}_noeat"] = GenLabel($opt);
    }
    else
      print
        "\tmov byte[si-1], {$defs['color']}\n".
        "\tmov ax,[si-2]\n".
        "\tjmp st_{$name}_atenot\n";
  }

  while($max_recolor > 0)
  {
    $n = $max_recolor*2 - 1;
    $l1 = "st_{$name}_recolor{$max_recolor}";
    --$max_recolor;
    $l2 = $max_recolor ? "st_{$name}_recolor{$max_recolor}" : "st_{$name}";
    print
      "$l1:\n".
        "\tmov byte[si-$n], {$defs['color']}\n".
        "\t; jmp $l2\n";
  }
  print "st_{$name}:\n";

  if(count($opts) == 1)
  {
    $opt = $opts[0];
    if($opt['noeat'] && !$opt['strings'])
    {
      $opt['noeat'] = false;
      print "\t; reduced version, noeat removed\n";
      print "\tjmp ".GenLabel($opt)."\n";
      $chain_jumps["st_{$name}"] = GenLabel($opt);
      continue;
    }
  }

  $actionset = Array();

  $defaultcase = -1;
  for($c=0; $c<256; ++$c)
    $actionset[$c] = -1;
  foreach($opts as $n => $option)
  {
    if($option['allowed'] === true)
      $defaultcase = $n;
    else foreach($option['allowed'] as $c => $dummy)
      $actionset[$c] = $n;
  }
  if($defaultcase >= 0)
    for($c=0; $c<256; ++$c)
      if($actionset[$c] < 0)
        $actionset[$c] = $defaultcase;

  print
      "\tmov byte[si+1], {$defs['color']}\n";

  if($actionset[10] != $actionset[254])
  {
    $o = $opts[$actionset[10]];
    $o['recolor'] = 0;
    print
      "\tcall test_newline\n".
      "\tje ".GenLabel($o)."\n";
  }

  print
      "\tlodsw\n";
  if(isset($reached_with_noeat[$name]))
  {
    print "; jmp st_{$name}_atenot\n";
    print "st_{$name}_atenot:\n";
  }

  //$actionset[0]   = $actionset[32];
  //$actionset[255] = $actionset[32];
  if($actionset[32] != $actionset[254])
  {
    $o = $opts[$actionset[32]];
    print
      "\tcall test_space\n".
      "\tje ".GenLabel($o)."\n";
  }

  if(true)
  {
    $default_label = GenLabel($opts[$actionset[254]]);
    $kchoices = Array();
    for($c=0; $c<=255; ++$c)
    {
      $a = $actionset[$c];
      if($c == 10) $a = $actionset[254];
      if($c == 32) $a = $actionset[254];
      $a = GenLabel($opts[$a]);
      if($a != $default_label)
        $kchoices[$c] = $a;
    }
    if(empty($kchoices))
      print "\tjmp $default_label ;huh?\n";
    else
      print RunCaseGen($default_label, $kchoices, true);
  }
  else
  {
    $actionset[-1] = $defaultcase;
    $actionset[256] = $defaultcase;

    /*if($actionset[10] != $actionset[9])
    {
      print "\tcall test_newline\n".
            "\tje ".GenLabel($opts[$actionset[10]])."\n";
      $actionset[10] = $actionset[9];
    }*/

    $prev = -2;
    for($c=1; $c<=254; ++$c)
    {
      if($actionset[$c] != $actionset[$c+1]
      && $actionset[$c] != $actionset[$c-1]
      && $actionset[$c+1] == $actionset[0])
      {
        print "\tcmp al, ".GenChar($c)."\n".
              "\tje ".GenLabel($opts[$actionset[$c]])."\n";
        $actionset[$c] = $actionset[$c-1];
      }
    }
    $prev = $actionset[0];
    for($c=1; $c<=255; ++$c)
    {
      if($actionset[$c] != $prev)
      {
        if($c == 71 || $c == 91 || $c == 103 || $c == 123 || $c == 58)
        {
          print "\tcmp al, ".GenChar($c-1)."\n".
                "\tjbe ".GenLabel($opts[$prev])."\n";
        }
        else
        {
          print "\tcmp al, ".GenChar($c)."\n".
                "\tjb ".GenLabel($opts[$prev])."\n";
        }
        $prev = $actionset[$c];
      }
    }
    print "\tjmp ".GenLabel($opts[$prev])."\n";
  }
}

print "\n\n";
foreach($buffer_states as $label1 => $label2)
{
  print
    "$label1:\n".
    "\tlea bx, [si-2]\n".
    "\tjmp $label2\n";
}

$strings_counter = 0;
$stringopt_counter = 0;
foreach($strings_states as $label => $sets)
{
  $ignorecase = $sets[0] == 2;
  $options    = $sets[1];
  $default    = $sets[2];

  $default_flush = "sfin{$strings_counter}";
  //$table_name    = "stab{$strings_counter}";

  $result_options = Array();
  $result_trans   = Array();

  if(0)
  {
    $option_labels = Array();
    ksort($options);
    foreach($options as $k=>$v)
    {
      $lbl = 's'.($stringopt_counter++);
      $option_labels[] = $lbl;
      echo "$lbl:\tdb ", strlen($k), ", '", $k, "'\n";
    }
    echo "dw ", join(',', $option_labels), "\n";
  }

  $prefixes = Array('' => 1);
  foreach($options as $k => $v)
  {
    $pfx = chr(strlen($k));
    $n = strlen($k);
    for($a=1; $a<=$n; ++$a)
    {
      @$prefixes[ substr($pfx.$k,0,$a) ] += 1;
    }

    $vn = "pfx_$v";
    $result_trans[ GenPrefixLabel($label, chr(strlen($k)).$k) ] = $vn;
    $result_options[$v] = $vn;
    unset($r);
  }

  /*print
    "{$table_name}:\n";
  foreach($options as $k => $v)
  {
    print "\tdw " . GenPrefixLabel($label, $k ) . "\n";
    print "\tdb '" . $k . "', 0\n";
  }*/

  /*print
    "{$default_flush}:\n".
    "\tmov si,bx\n".
    "\tjmp {$default}\n";*/
  $stringtests = Array();
  foreach($prefixes as $k => $prefix_use_count)
  {
    $nextchar_choices = Array();
    $onlychoice = Array();
    $pos = strlen($k);
    foreach($options as $k2 => $v)
    {
      $k2 = chr(strlen($k2)) . $k2;
      if(substr($k2, 0, $pos) == $k)
      {
        $n = GenPrefixLabel($label, $k2);
        if($k != ''
        && strlen($k2) == ord($k2[0])+1)
          $n = $result_trans[$n];

        $ch = $k2[$pos];
        $onlychoice = Array( substr($k2, $pos), $n, substr($k2,1) );
        if($ignorecase)
          $nextchar_choices[ ord(strtoupper($ch)) ] = $k2[$pos];
        else
          $nextchar_choices[ ord($ch) ] = $k2[$pos];
      }
    }

    if(count($nextchar_choices) == 0) continue;

    if($prefix_use_count == 1
    && count($nextchar_choices) == 1 && strlen($onlychoice[0]) > 0)
    {
      $lbl = $onlychoice[0].'_'.$onlychoice[1];
      $stringtest[$lbl][0] = $onlychoice[0]; // string
      $stringtest[$lbl][1] = $onlychoice[1]; // ok-label
      $stringtest[$lbl][2][] = GenPrefixLabel($label, $k);
      unset($options[ $onlychoice[2] ]);
    }
    else
    {
      print GenPrefixLabel($label, $k).":\n";
      if($k == '')
      {
        print
          "\txchg bx,si\n".
          "\n".
          "\tsub bx, 2\n".
          "\tmov ax, bx\n".
          "\tsub ax, si\n".
          "\tshr ax, 1\n".
          "\tmov cx, ax\n";
        // Goal of the above sequence:
        //     cx = (si-bx)/2 - 1
        //     ax = cx
        //     si SWAP bx
      }
      else
      {
        if($ignorecase)
          print "\tcall takefrombuffer_uc\n";
        else
          print "\tlodsw\n";
      }

      $kchoices = Array();
      foreach($nextchar_choices as $k2 => $v)
      {
        $n = GenPrefixLabel($label, $k . $v);
        if($k != ''
        && strlen($k.$v) == ord($k[0])+1)
          $n = $result_trans[$n];
        $kchoices[$k2] = $n;
      }
      print RunCasegen($default_flush, $kchoices);
    }
  }

  $label_tab = Array();
  foreach($stringtest as $test)
  {
    foreach($test[2] as $label)
      print "$label:\n";
    if($ignorecase)
      print "\tcall test_string_uc\n";
    else
      print "\tcall test_string\n";

    $lbl = "l_{$default_flush}_{$test[1]}";
    $label_tab[$lbl] = Array($default_flush, $test[1]);
    print "\tdw $lbl\n";
    print "\tdb '" . strtoupper($test[0]) . "'\n";
  }
  foreach($label_tab as $lbl => $data)
    print "$lbl:\n\tdw {$data[0]}, {$data[1]}\n";

  ksort($result_options);
  $default_generated = false;
  foreach($result_options as $target_state => $target_state_name)
  {
    foreach($result_trans as $opt_label => $v)
      if($v == $target_state_name)
        print "; $opt_label:\n";
    print "$target_state_name:\n";
    print "\tmov ah, {$parser->state[$target_state]['color']}\n".
          "\tcall paint_token\n";
    $d = "st_{$target_state}_noeat";
    if(!$default_generated
    && ($d == $default || @$chain_jumps[$d] == $default))
    {
      print "$default_flush:";
      $default_generated = true;
    }
    print "\tlea si,[bx+2]\n".
          "\tjmp $d\n";
  }
  if(!$default_generated)
  {
    print
      "$default_flush:".
      "\tlea si,[bx+2]\n".
      "\tjmp $default\n";
  }

  ++$strings_counter;
}

function GenLabel($options)
{
  $label = "st_".$options['state'];
  if(@$options['noeat']) $label .= "_noeat";
  if(@$options['recolor'])
    $label .= "_recolor" . -$options['recolor'];
  if(@$options['buffer'])
    $label .= "_buffer";
  if(@$options['strings'])
    $label .= "_strings{$options['strings']}";
  return $label;
}
function GenChar($c)
{
  if($c == 39 || $c == 92) return $c;
  if($c >= 32 && $c < 126) return "'" . chr($c) . "'";
  return $c;
}

function GenPrefixLabel($label, $s)
{
  if($s == '')
    return "$label";

  if(strlen($s) == ord($s[0])+1)
  {
    return sprintf('pfx%X_%s', crc32($label)&15,
       str_replace(Array('$',chr(0)), Array('_s', '_n'), substr($s,1))
                  );
  }
  return sprintf('pfx%X_%d_%s', crc32($label)&15, ord($s[0]),
     str_replace(Array('$',chr(0)), Array('_s', '_n'), substr($s,1))
                );
}

function RunCasegen($default_flush, $choices, $always_casegen = false)
{
  static $counter=0; ++$counter;

  ksort($choices);

  if($always_casegen
  || count($choices) <= 2
  || (max(array_keys($choices))-min(array_keys($choices)))
     <= count($choices)+2
  || count($choices) >= 128
   )
  {
    $casegen_script = "$default_flush $counter\n";
    foreach($choices as $k => $v)
      $casegen_script .= "$k $v\n";
    print `echo '$casegen_script' | ./casegen-x86`;
  }
  else
  {
    $dummies = Array($default_flush => true);

    print "\tcall binarysearch\n".
          "\tdb ".count($choices)."\n".
          "\tdw $default_flush\n";
    $c=0;
    foreach($choices as $k => $v)
    {
      print $c++ ? ', ' : "\tdb ";
      print GenChar($k);
    }
    print "\n";
    $c=0;
    foreach($choices as $k => $v)
    {
      print $c++ ? ', ' : "\tdw ";
      print $v;
      $dummies[$v] = true;
    }
    print "\n";
    foreach($dummies as $k => $v)
      print "\t; jmp $k ; Dummy jump to prevent dead code elimination\n";
  }
}

?>

End:

<?php

$s = ob_get_clean();

$s = preg_replace(
  "/jmp ([a-z0-9_A-Z]*)\n((?:;[^\n]*\n)*)\\1:/",
  "; jmp \\1 ;Redundant jump\n\\2\\1:",
  $s);

foreach($chain_jumps as $k => $v)
  foreach(Array('jmp','je','jne','jz','jnz','jb','ja','jbe','jae') as $jmp)
    $s = str_replace("$jmp $k\n",
                     "$jmp {$v} ; chain jump of {$k}\n",
                     $s);

for(;;) // Remove dead code
{
  $label_mask = '(?:st_|sfin)[a-z0-9_A-Z]+';
  $mat = Array();
  preg_match_all("/\t?[; ]*(?:jmp|je|jne|jz|jnz|jb|ja|jbe|jae) *($label_mask)/",
                 $s,
                 $mat);
  $used_labels  = Array();
  foreach($mat[1] as $v) $used_labels[$v] = true;
  #print_r($used_labels);
  $t = '';
  $erasing = false;
  foreach(explode("\n", $s) as $line)
  {
    if(strpos($line,":") !== false)
    {
      $known_label = preg_match("/^($label_mask):/", $line, $mat);
      if(!$known_label)
        $erasing = false;
      else
        $erasing = !isset($used_labels[$mat[1]]);
    }
    if($erasing)
      $t .= ";erased line;\t$line\n";
    else
      $t .= "$line\n";
  }
  $s = $t;


  $t = preg_replace(
    "/jmp ([a-z0-9_A-Z]*)\n((?:;[^\n]*\n)*)\\1:/",
    "; jmp \\1 ;Redundant jump\n\\2\\1:",
    $s);
  if($t == $s) break;
  $s = $t;
}


print $s;
